<?php

/*
Plugin Name: Rezerwujestolik
Description: Wtyczka do wyświetlania modalnego okienka z rezerwacjami.
Version: 1.0
Author: Rezerwujestolik.pl
*/


// Link do ustawień w panelu administratora
add_action('admin_menu', 'rezerwujestolik_plugin_menu');
function rezerwujestolik_plugin_menu()
{
    add_options_page('Ustawienia Rezerwujestolik', 'Rezerwujestolik', 'manage_options', 'rezerwujestolik-settings', 'rezerwujestolik_settings_page');
}

// Sekcja ustawień i pola do ustawień w panelu administratora
add_action('admin_init', 'rezerwujestolik_settings');

function rezerwujestolik_settings()
{
    register_setting('rezerwujestolik-settings-group', 'rezerwujestolik_button_bg_color');
    register_setting('rezerwujestolik-settings-group', 'rezerwujestolik_button_text_color');
    register_setting('rezerwujestolik-settings-group', 'rezerwujestolik_button_border_color');
    register_setting('rezerwujestolik-settings-group', 'rezerwujestolik_button_text');
    register_setting('rezerwujestolik-settings-group', 'rezerwujestolik_url');
}

// Funkcja wyświetlająca stronę ustawień w panelu administratora
function rezerwujestolik_settings_page()
{
    ?>
    <div class="wrap">


        <h2 style="display: flex; gap: 15px; align-items: center">
            <svg viewBox="0 0 71 71" fill="none" xmlns="http://www.w3.org/2000/svg" class="w-20 h-20 fill-current text-gray-500" style="width: 80px; height: 80px;">
                <rect x="29.8431" y="20.6508" width="29" height="29" rx="10" transform="rotate(-45 29.8431 20.6508)" fill="#C3C1DE"></rect>
                <rect x="0.144653" y="50.3492" width="29" height="29" rx="10" transform="rotate(-45 0.144653 50.3492)" fill="#C3C1DE"></rect>
                <rect x="0.851776" y="35.5" width="49" height="49" transform="rotate(-45 0.851776 35.5)" fill="#4F46E5"></rect>
                <rect x="20.6508" y="41.1569" width="29" height="29" rx="10" transform="rotate(-135 20.6508 41.1569)" fill="#C3C1DE"></rect>
                <rect x="50.3492" y="70.8553" width="29" height="29" rx="10" transform="rotate(-135 50.3492 70.8553)" fill="#C3C1DE"></rect>
            </svg>
            Ustawienia Rezerwujestolik
        </h2>
        <form method="post" action="options.php">
            <?php settings_fields('rezerwujestolik-settings-group'); ?>
            <?php do_settings_sections('rezerwujestolik-settings-group'); ?>
            <table class="form-table" style="width: 100%">
                <tr valign="top">
                    <th scope="row">
                        Kolor przycisku:
                    </th>
                    <td>
                        <input type="color" name="rezerwujestolik_button_bg_color" value="<?php echo get_option('rezerwujestolik_button_bg_color', '#6366f1'); ?>"/>
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row">
                        Kolor tekstu na przycisku:
                    </th>
                    <td>
                        <input type="color" name="rezerwujestolik_button_text_color" value="<?php echo get_option('rezerwujestolik_button_text_color', '#ffffff'); ?>"/>
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row">
                        Kolor obramowania na przycisku:
                    </th>
                    <td>
                        <input type="color" name="rezerwujestolik_button_border_color" value="<?php echo get_option('rezerwujestolik_button_border_color', '#6366f1'); ?>"/>
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row">
                        Tekst na przycisku:
                    </th>
                    <td>
                        <input type="text" name="rezerwujestolik_button_text" value="<?php echo get_option('rezerwujestolik_button_text', 'Rezerwuję'); ?>" size="50"/>
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row">
                        Adres URL okna:
                    </th>
                    <td>
                        <input type="text" name="rezerwujestolik_url" value="<?php echo get_option('rezerwujestolik_url'); ?>" size="50"/>
                    </td>
                </tr>


                <tr valign="top">
                    <th scope="row">
                        Aby wyświetlić guzik użyj shortcode:
                    </th>
                    <td>
                        <h5>
                            Wstaw shortcode w taki sposób
                        </h5>
                        <code>
                            [rezerwujestolik_button]

                        </code>
                        <h5>
                            Lub jeśli w jakimś miejscu chcesz użyć innych kolorów to można podać parametry w taki sposób
                        </h5>
                        <code>
                            [rezerwujestolik_button text="Rezerwuje teraz" bg="transparent" color="#04a019" border="#04a019"]

                        </code>
                        <h5>
                            Lub w każdym innym guziku, lub linku, dodaj klasę css, która otworzy okienko
                        </h5>
                        <code>
                             class="rezerujestolik-button"

                        </code>

                    </td>
                </tr>

            </table>
            <?php submit_button(); ?>
        </form>
    </div>
    <?php
}

// Styl dla modalnego okna
function rezerwujestolik_modal_styles()
{
    wp_enqueue_style('rezerwujestolik-modal-styles', plugin_dir_url(__FILE__) . 'modal.css');
}

add_action('wp_enqueue_scripts', 'rezerwujestolik_modal_styles');

// Skrypty dla modalnego okna
function rezerwujestolik_modal_scripts()
{
    wp_enqueue_script('rezerwujestolik-modal-scripts', plugin_dir_url(__FILE__) . 'modal.js', array('jquery'), null, true);
}

add_action('wp_enqueue_scripts', 'rezerwujestolik_modal_scripts');


function rezerwujestolik_button_shortcode($atts)
{

    $atts = shortcode_atts(array(
        'text' => get_option('rezerwujestolik_button_text', 'Rezerwuję teraz'),
        'bg' => get_option('rezerwujestolik_button_bg_color', '#6366f1'),
        'color' => get_option('rezerwujestolik_button_text_color', '#ffffff'),
        'border' => get_option('rezerwujestolik_button_border_color', '#6366f1'),
    ), $atts);
    $outputBtn = '<button style="background-color: ' . esc_attr($atts['bg']) . '; color: ' . esc_attr($atts['color']) . '; border-color: ' . esc_attr($atts['border']) . ';" type="button" class="rezerujestolik-button">' . $atts['text'] . '</button>';

    return $outputBtn;
}



add_shortcode('rezerwujestolik_button', 'rezerwujestolik_button_shortcode');


// Funkcja do renderowania okna modalnego
function rezerwujestolik_render_modal($url)
{
    // Utwórz modalne okienko, które ukryje się początkowo
    $output = '<div id="rezerwujestolik-modal" class="rezerwujestolik-modal" style="display: none;">';
    $output .= '<div class="rezerwujestolik-modal-content">';
    $output .= '<iframe id="rezerujestolik-frame" src="' . esc_url($url) . '" frameborder="0" allowfullscreen></iframe>';
    $output .= '<button type="button" id="rezerwujestolik-close-button">&times;</button>';
    $output .= '</div>';
    $output .= '</div>';

    echo $output; // Wyświetl kod HTML okna modalnego
}

// Dodaj funkcję do renderowania okna modalnego w stopce strony WordPress
function rezerwujestolik_add_modal_to_footer()
{
    // Pobierz URL z ustawień wtyczki
    $url = get_option('rezerwujestolik_url', 'https://rezerwujestolik.pl/p/restauracja-demo?modal');

    // Wywołaj funkcję renderującą okno modalne
    rezerwujestolik_render_modal($url);
}

// Wywołanie funkcji renderującą okno modalne w stopce strony WordPress
add_action('wp_footer', 'rezerwujestolik_add_modal_to_footer');
